Index: graph_displayer_canvas-event.cc
===================================================================
--- graph_displayer_canvas-event.cc	(revision 201)
+++ graph_displayer_canvas-event.cc	(revision 187)
@@ -581,193 +621,159 @@
 bool GraphDisplayerCanvas::mapEditEventHandler(GdkEvent* e)
 {
-  MapStorage& ms = *mytab.mapstorage;
-
   if(actual_tool==MAP_EDIT)
-  {
-    switch(e->type)
-    {
-      case GDK_BUTTON_PRESS:
-        {
-          //for determine, whether it was an edge
-          Edge clicked_edge=INVALID;
-          //for determine, whether it was a node
-          Node clicked_node=INVALID;
-
-          window_to_world (e->button.x, e->button.y, clicked_x, clicked_y);
-          active_item=(get_item_at(clicked_x, clicked_y));
-
-          //find the activated item between text of nodes
-          for (NodeIt i(ms.graph); i!=INVALID; ++i)
-          {
-            //at the same time only one can be active
-            if(nodetextmap[i]==active_item)
-            {
-              clicked_node=i;
-            }
-          }
-
-          //if there was not, search for it between nodes
-          if(clicked_node==INVALID)
-          {
-            for (NodeIt i(ms.graph); i!=INVALID; ++i)
-            {
-              //at the same time only one can be active
-              if(nodesmap[i]==active_item)
-              {
-                clicked_node=i;
-              }
-            }
-          }
-
-          if(clicked_node==INVALID)
-          {
-            //find the activated item between texts
-            for (EdgeIt i(ms.graph); i!=INVALID; ++i)
-            {
-              //at the same time only one can be active
-              if(edgetextmap[i]==active_item)
-              {
-                clicked_edge=i;
-              }
-            }
-
-            //if it was not between texts, search for it between edges
-            if(clicked_edge==INVALID)
-            {
-              for (EdgeIt i(ms.graph); i!=INVALID; ++i)
-              {
-                //at the same time only one can be active
-                if((edgesmap[i]->getLine())==active_item)
-                {
-                  clicked_edge=i;
-                }
-              }
-            }
-          }
-
-          //if it was really a node...
-          if(clicked_node!=INVALID)
-          {
-            // the id map is not editable
-            if (nodemap_to_edit == "label") return 0;
-
-            //and there is activated map
-            if(nodetextmap[clicked_node]->property_text().get_value()!="")
-            {
-              //activate the general variable for it
-              active_node=clicked_node;
-
-              //create a dialog
-              Gtk::Dialog dialog("Edit value", true);
-              dialog.add_button(Gtk::Stock::CANCEL, Gtk::RESPONSE_CANCEL);
-              dialog.add_button(Gtk::Stock::OK, Gtk::RESPONSE_ACCEPT);
-              Gtk::VBox* vbox = dialog.get_vbox();
-
-              /*
-              Gtk::SpinButton spin(0.0, 4);
-              spin.set_increments(1.0, 10.0);
-              spin.set_range(-1000000.0, 1000000.0);
-              spin.set_numeric(true);
-              spin.set_value(atof(nodetextmap[active_node]->property_text().get_value().c_str()));
-              vbox->add(spin);
-              spin.show();
-              */
-              Gtk::Entry entry;
-              entry.set_text(nodetextmap[active_node]->property_text().get_value());
-              vbox->add(entry);
-              entry.show();
-
-              switch (dialog.run())
-              {
-                case Gtk::RESPONSE_NONE:
-                case Gtk::RESPONSE_CANCEL:
-                  break;
-                case Gtk::RESPONSE_ACCEPT:
-                  switch (ms.getNodeMapElementType(nodemap_to_edit))
-                  {
-                    case MapValue::NUMERIC:
-                      ms.set(nodemap_to_edit, active_node,
-                          atof(entry.get_text().c_str()));
-                      break;
-                    case MapValue::STRING:
-                      ms.set(nodemap_to_edit, active_node,
-                          static_cast<std::string>(entry.get_text()));
-                      break;
-                  }
-                  nodetextmap[active_node]->property_text().set_value(
-                      static_cast<std::string>(ms.get(nodemap_to_edit, active_node)));
-
-                  //mapwin.updateNode(active_node);
-                  //mapwin.updateNode(Node(INVALID));
-                  propertyUpdate(Node(INVALID));
-              }
-            }
-          }
-          else
-            //if it was really an edge...
-            if(clicked_edge!=INVALID)
-            {
-              // the id map is not editable
-              if (edgemap_to_edit == "label") return 0;
-
-              //and there is activated map
-              if(edgetextmap[clicked_edge]->property_text().get_value()!="")
-              {
-                //activate the general variable for it
-                active_edge=clicked_edge;
-
-                //create a dialog
-                Gtk::Dialog dialog("Edit value", true);
-                dialog.add_button(Gtk::Stock::CANCEL, Gtk::RESPONSE_CANCEL);
-                dialog.add_button(Gtk::Stock::OK, Gtk::RESPONSE_ACCEPT);
-                Gtk::VBox* vbox = dialog.get_vbox();
-
-                /*
-                Gtk::SpinButton spin(0.0, 4);
-                spin.set_increments(1.0, 10.0);
-                spin.set_range(-1000000.0, 1000000.0);
-                spin.set_numeric(true);
-                spin.set_value(atof(edgetextmap[active_edge]->property_text().get_value().c_str()));
-                vbox->add(spin);
-                spin.show();
-                */
-                Gtk::Entry entry;
-                entry.set_text(edgetextmap[active_edge]->property_text().get_value());
-                vbox->add(entry);
-                entry.show();
-
-                std::cout << edgemap_to_edit << std::endl;
-                switch (dialog.run())
-                {
-                  case Gtk::RESPONSE_NONE:
-                  case Gtk::RESPONSE_CANCEL:
-                    break;
-                  case Gtk::RESPONSE_ACCEPT:
-                    switch (ms.getEdgeMapElementType(edgemap_to_edit))
-                    {
-                      case MapValue::NUMERIC:
-                        ms.set(edgemap_to_edit, active_edge,
-                            atof(entry.get_text().c_str()));
-                        break;
-                      case MapValue::STRING:
-                        ms.set(edgemap_to_edit, active_edge,
-                            static_cast<std::string>(entry.get_text()));
-                        break;
-                    }
-                    edgetextmap[active_edge]->property_text().set_value(
-                        static_cast<std::string>(ms.get(edgemap_to_edit, active_edge)));
-
-                    //mapwin.updateEdge(active_edge);
-                    //                   mapwin.updateEdge(Edge(INVALID));
-                    propertyUpdate(Edge(INVALID));
-                }
-              }
-            }
-          break;
-        }
-      default:
-        break;
-    }
-  }
+    {
+      switch(e->type)
+	{
+	case GDK_BUTTON_PRESS:
+	  {
+	    //for determine, whether it was an edge
+	    Edge clicked_edge=INVALID;
+	    //for determine, whether it was a node
+	    Node clicked_node=INVALID;
+
+	    window_to_world (e->button.x, e->button.y, clicked_x, clicked_y);
+	    active_item=(get_item_at(clicked_x, clicked_y));
+
+	    //find the activated item between text of nodes
+	    for (NodeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
+	      {
+		//at the same time only one can be active
+		if(nodetextmap[i]==active_item)
+		  {
+		    clicked_node=i;
+		  }
+	      }
+
+	    //if there was not, search for it between nodes
+	    if(clicked_node==INVALID)
+	      {
+		for (NodeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
+		  {
+		    //at the same time only one can be active
+		    if(nodesmap[i]==active_item)
+		      {
+			clicked_node=i;
+		      }
+		  }
+	      }
+
+	    if(clicked_node==INVALID)
+	      {
+		//find the activated item between texts
+		for (EdgeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
+		  {
+		    //at the same time only one can be active
+		    if(edgetextmap[i]==active_item)
+		      {
+			clicked_edge=i;
+		      }
+		  }
+
+		//if it was not between texts, search for it between edges
+		if(clicked_edge==INVALID)
+		  {
+		    for (EdgeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
+		      {
+			//at the same time only one can be active
+			if((edgesmap[i]->getLine())==active_item)
+			  {
+			    clicked_edge=i;
+			  }
+		      }
+		  }
+	      }
+
+	    //if it was really a node...
+	    if(clicked_node!=INVALID)
+	      {
+		// the id map is not editable
+		if (nodemap_to_edit == "label") return 0;
+
+		//and there is activated map
+		if(nodetextmap[clicked_node]->property_text().get_value()!="")
+		  {
+		    //activate the general variable for it
+		    active_node=clicked_node;
+
+		    //create a dialog
+		    Gtk::Dialog dialog("Edit value", true);
+		    dialog.add_button(Gtk::Stock::CANCEL, Gtk::RESPONSE_CANCEL);
+		    dialog.add_button(Gtk::Stock::OK, Gtk::RESPONSE_ACCEPT);
+		    Gtk::VBox* vbox = dialog.get_vbox();
+		    Gtk::SpinButton spin(0.0, 4);
+		    spin.set_increments(1.0, 10.0);
+		    spin.set_range(-1000000.0, 1000000.0);
+		    spin.set_numeric(true);
+		    spin.set_value(atof(nodetextmap[active_node]->property_text().get_value().c_str()));
+		    vbox->add(spin);
+		    spin.show();
+		    switch (dialog.run())
+		      {
+		      case Gtk::RESPONSE_NONE:
+		      case Gtk::RESPONSE_CANCEL:
+			break;
+		      case Gtk::RESPONSE_ACCEPT:
+			double new_value = spin.get_value();
+			(*(mytab.mapstorage).nodemap_storage[nodemap_to_edit])[active_node] =
+			  new_value;
+			std::ostringstream ostr;
+			ostr << new_value;
+			nodetextmap[active_node]->property_text().set_value(ostr.str());
+			//mapwin.updateNode(active_node);
+			//mapwin.updateNode(Node(INVALID));
+			propertyUpdate(Node(INVALID));
+		      }
+		  }
+	      }
+	    else
+	      //if it was really an edge...
+	      if(clicked_edge!=INVALID)
+		{
+		  // the id map is not editable
+		  if (edgemap_to_edit == "label") return 0;
+
+		  //and there is activated map
+		  if(edgetextmap[clicked_edge]->property_text().get_value()!="")
+		    {
+		      //activate the general variable for it
+		      active_edge=clicked_edge;
+
+		      //create a dialog
+		      Gtk::Dialog dialog("Edit value", true);
+		      dialog.add_button(Gtk::Stock::CANCEL, Gtk::RESPONSE_CANCEL);
+		      dialog.add_button(Gtk::Stock::OK, Gtk::RESPONSE_ACCEPT);
+		      Gtk::VBox* vbox = dialog.get_vbox();
+		      Gtk::SpinButton spin(0.0, 4);
+		      spin.set_increments(1.0, 10.0);
+		      spin.set_range(-1000000.0, 1000000.0);
+		      spin.set_numeric(true);
+		      spin.set_value(atof(edgetextmap[active_edge]->property_text().get_value().c_str()));
+		      vbox->add(spin);
+		      spin.show();
+		      switch (dialog.run())
+			{
+			case Gtk::RESPONSE_NONE:
+			case Gtk::RESPONSE_CANCEL:
+			  break;
+			case Gtk::RESPONSE_ACCEPT:
+			  double new_value = spin.get_value();
+			  (*(mytab.mapstorage).edgemap_storage[edgemap_to_edit])[active_edge] =
+			    new_value;
+			  std::ostringstream ostr;
+			  ostr << new_value;
+			  edgetextmap[active_edge]->property_text().set_value(
+									      ostr.str());
+			  //mapwin.updateEdge(active_edge);
+			  //                   mapwin.updateEdge(Edge(INVALID));
+			  propertyUpdate(Edge(INVALID));
+			}
+		    }
+		}
+	    break;
+	  }
+	default:
+	  break;
+	}
+    }
   return false;  
 }
@@ -777,5 +783,5 @@
   delete(nodetextmap[node_to_delete]);
   delete(nodesmap[node_to_delete]);
-  mytab.mapstorage->graph.erase(node_to_delete);
+  (mytab.mapstorage).graph.erase(node_to_delete);
 }
 
@@ -784,5 +790,5 @@
   delete(edgetextmap[edge_to_delete]);
   delete(edgesmap[edge_to_delete]);
-  mytab.mapstorage->graph.erase(edge_to_delete);
+  (mytab.mapstorage).graph.erase(edge_to_delete);
 }
 
@@ -804,5 +810,5 @@
     else
     {
-      for (EdgeIt i(mytab.mapstorage->graph); i!=INVALID; ++i)
+      for (EdgeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
       {
         if(edgesmap[i]==active_bre)
@@ -814,32 +820,30 @@
   }
   else
-  {
-    if(forming_edge!=INVALID)
-    {
-      forming_edge=INVALID;
-    }
-    else
-    {
-      std::cerr << "ERROR!!!! Invalid edge found!" << std::endl;
-    }
-  }
+    {
+      if(forming_edge!=INVALID)
+	{
+	  forming_edge=INVALID;
+	}
+      else
+	{
+	  std::cerr << "ERROR!!!! Invalid edge found!" << std::endl;
+	}
+    }
 }
 
 void GraphDisplayerCanvas::moveNode(double dx, double dy, Gnome::Canvas::Item * item, Node node)
 {
-  MapStorage& ms = *mytab.mapstorage;
-
   Gnome::Canvas::Item * moved_item=item;
   Node moved_node=node;
 
   if(item==NULL && node==INVALID)
-  {
-    moved_item=active_item;
-    moved_node=active_node;
-  }
+    {
+      moved_item=active_item;
+      moved_node=active_node;
+    }
   else
-  {
-    isbutton=1;
-  }
+    {
+      isbutton=1;
+    }
 
   //repositioning node and its text
@@ -848,63 +852,65 @@
 
   // the new coordinates of the centre of the node 
-  double coord_x = dx + ms.getNodeCoords(moved_node).x;
-  double coord_y = dy + ms.getNodeCoords(moved_node).y;
+  double coord_x = dx + (mytab.mapstorage).coords[moved_node].x;
+  double coord_y = dy + (mytab.mapstorage).coords[moved_node].y;
 
   // write back the new coordinates to the coords map
-  ms.setNodeCoords(moved_node, XY(coord_x, coord_y));
+  (mytab.mapstorage).coords.set(moved_node, XY(coord_x, coord_y));
 
   //all the edges connected to the moved point has to be redrawn
-  for(OutEdgeIt ei(ms.graph,moved_node);ei!=INVALID;++ei)
-  {
-    XY arrow_pos;
-
-    if (ms.graph.source(ei) == ms.graph.target(ei))
-    {
-      arrow_pos = ms.getArrowCoords(ei) + XY(dx, dy);
-    }
-    else
-    {
-      XY moved_node_1(coord_x - dx, coord_y - dy);
-      XY moved_node_2(coord_x, coord_y);
-      Node target = ms.graph.target(ei);
-      XY fix_node = ms.getNodeCoords(target);
-      XY old_arrow_pos(ms.getArrowCoords(ei));
-
-      arrow_pos = calcArrowPos(moved_node_1, moved_node_2, fix_node, old_arrow_pos, isbutton);
-    }
-
-    ms.setArrowCoords(ei, arrow_pos);
-    edgesmap[ei]->draw();
-
-    //reposition of edgetext
-    XY text_pos=ms.getArrowCoords(ei);
-    text_pos+=(XY(10,10));
-    edgetextmap[ei]->property_x().set_value(text_pos.x);
-    edgetextmap[ei]->property_y().set_value(text_pos.y);
-  }
-
-  for(InEdgeIt ei(ms.graph,moved_node);ei!=INVALID;++ei)
-  {
-    if (ms.graph.source(ei) != ms.graph.target(ei))
-    {
-      XY moved_node_1(coord_x - dx, coord_y - dy);
-      XY moved_node_2(coord_x, coord_y);
-      Node source = ms.graph.source(ei);
-      XY fix_node = ms.getNodeCoords(source);
-      XY old_arrow_pos(ms.getArrowCoords(ei));
-
+  for(OutEdgeIt ei((mytab.mapstorage).graph,moved_node);ei!=INVALID;++ei)
+    {
       XY arrow_pos;
-      arrow_pos = calcArrowPos(moved_node_1, moved_node_2, fix_node, old_arrow_pos, isbutton);
-
-      ms.setArrowCoords(ei, arrow_pos);
+
+      if (mytab.mapstorage.graph.source(ei) == mytab.mapstorage.graph.target(ei))
+	{
+	  arrow_pos = mytab.mapstorage.arrow_pos[ei] + XY(dx, dy);
+	}
+      else
+	{
+	  XY moved_node_1(coord_x - dx, coord_y - dy);
+	  XY moved_node_2(coord_x, coord_y);
+	  Node target = mytab.mapstorage.graph.target(ei);
+	  XY fix_node(mytab.mapstorage.coords[target].x,
+		      mytab.mapstorage.coords[target].y);
+	  XY old_arrow_pos(mytab.mapstorage.arrow_pos[ei]);
+
+	  arrow_pos = calcArrowPos(moved_node_1, moved_node_2, fix_node, old_arrow_pos, isbutton);
+	}
+
+      mytab.mapstorage.arrow_pos.set(ei, arrow_pos);
       edgesmap[ei]->draw();
 
       //reposition of edgetext
-      XY text_pos=ms.getArrowCoords(ei);
+      XY text_pos=mytab.mapstorage.arrow_pos[ei];
       text_pos+=(XY(10,10));
       edgetextmap[ei]->property_x().set_value(text_pos.x);
       edgetextmap[ei]->property_y().set_value(text_pos.y);
     }
-  }
+
+  for(InEdgeIt ei((mytab.mapstorage).graph,moved_node);ei!=INVALID;++ei)
+    {
+      if (mytab.mapstorage.graph.source(ei) != mytab.mapstorage.graph.target(ei))
+	{
+	  XY moved_node_1(coord_x - dx, coord_y - dy);
+	  XY moved_node_2(coord_x, coord_y);
+	  Node source = mytab.mapstorage.graph.source(ei);
+	  XY fix_node(mytab.mapstorage.coords[source].x,
+		      mytab.mapstorage.coords[source].y);
+	  XY old_arrow_pos(mytab.mapstorage.arrow_pos[ei]);
+
+	  XY arrow_pos;
+	  arrow_pos = calcArrowPos(moved_node_1, moved_node_2, fix_node, old_arrow_pos, isbutton);
+
+	  mytab.mapstorage.arrow_pos.set(ei, arrow_pos);
+	  edgesmap[ei]->draw();
+
+	  //reposition of edgetext
+	  XY text_pos=mytab.mapstorage.arrow_pos[ei];
+	  text_pos+=(XY(10,10));
+	  edgetextmap[ei]->property_x().set_value(text_pos.x);
+	  edgetextmap[ei]->property_y().set_value(text_pos.y);
+	}
+    }
 }
 
@@ -921,47 +927,47 @@
   //the actual value belongs to
   for (int i=0;i<=5;i++)
-  {
-    if(((double)i/6<pos)&&(pos<=(double(i+1)/6)))
-    {
-      phase=i;
-    }
-  }
+    {
+      if(((double)i/6<pos)&&(pos<=(double(i+1)/6)))
+	{
+	  phase=i;
+	}
+    }
   if(phase<6)
-  {
-    //within its 1/6 long phase the relativ position
-    //determines the power of the color changed in
-    //that phase
-    //we normalize that to one, to be able to give percentage
-    //value for the function
-    double rel_pos=(pos-(phase/6.0))*6.0;
-
-    switch(phase)
-    {
-      case 0:
-        color.set_rgb_p (1, 0, 1-rel_pos);
-        break;
-      case 1:
-        color.set_rgb_p (1, rel_pos, 0);
-        break;
-      case 2:
-        color.set_rgb_p (1-rel_pos, 1, 0);
-        break;
-      case 3:
-        color.set_rgb_p (0, 1, rel_pos);
-        break;
-      case 4:
-        color.set_rgb_p (0, 1-rel_pos, 1);
-        break;
-      case 5:
-        color.set_rgb_p ((rel_pos/3.0), 0, 1);
-        break;
-      default:
-        std::cout << "Wrong phase: " << phase << " " << pos << std::endl;
-    }
-  }
+    {
+      //within its 1/6 long phase the relativ position
+      //determines the power of the color changed in
+      //that phase
+      //we normalize that to one, to be able to give percentage
+      //value for the function
+      double rel_pos=(pos-(phase/6))*6;
+
+      switch(phase)
+	{
+	case 0:
+	  color.set_rgb_p (1, 0, 1-rel_pos);
+	  break;
+	case 1:
+	  color.set_rgb_p (1, rel_pos, 0);
+	  break;
+	case 2:
+	  color.set_rgb_p (1-rel_pos, 1, 0);
+	  break;
+	case 3:
+	  color.set_rgb_p (0, 1, rel_pos);
+	  break;
+	case 4:
+	  color.set_rgb_p (0, 1-rel_pos, 1);
+	  break;
+	case 5:
+	  color.set_rgb_p ((rel_pos/3), 0, 1);
+	  break;
+	default:
+	  std::cout << "Wrong phase: " << phase << " " << pos << std::endl;
+	}
+    }
   else
-  {
-    std::cout << "Wrong phase: " << phase << " " << pos << std::endl;
-  }
+    {
+      std::cout << "Wrong phase: " << phase << " " << pos << std::endl;
+    }
   return color;
 }
Index: graph_displayer_canvas-node.cc
===================================================================
--- graph_displayer_canvas-node.cc	(revision 201)
+++ graph_displayer_canvas-node.cc	(revision 179)
@@ -17,7 +17,5 @@
  */
 
-#include <graph_displayer_canvas.h>
-#include <mapstorage.h>
-#include <nbtab.h>
+#include "graph_displayer_canvas.h"
 #include <cmath>
 
@@ -26,25 +24,15 @@
 int GraphDisplayerCanvas::changeNodeRadius (std::string mapname, Node node)
 {
-  MapStorage& ms = *mytab.mapstorage;
-
+  Graph::NodeMap<double> * actual_map;
   double min, max;
-
-  {
-    NodeIt n(ms.graph);
-    min = max = ms.get(mapname, n);
-    for (; n != INVALID; ++n)
-    {
-      if (static_cast<double>(ms.get(mapname, n)) > max)
-        max = ms.get(mapname, n);
-      if (static_cast<double>(ms.get(mapname, n)) < min)
-        min = ms.get(mapname, n);
-    }
-  }
-
-  if(node==INVALID)
-    {
-      for (NodeIt i(ms.graph); i!=INVALID; ++i)
-	{
-	  double v=fabs(ms.get(mapname,i));
+  min=(mytab.mapstorage).minOfNodeMap(mapname);
+  max=(mytab.mapstorage).maxOfNodeMap(mapname);
+  actual_map=((mytab.mapstorage).nodemap_storage)[mapname];
+
+  if(node==INVALID)
+    {
+      for (NodeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
+	{
+	  double v=fabs((*actual_map)[i]);
 	  int w;
 	  if(autoscale)
@@ -113,14 +101,12 @@
 int GraphDisplayerCanvas::resetNodeRadius (Node node)
 {
-  MapStorage& ms = *mytab.mapstorage;
-
   double min, max;
   min=node_property_defaults[N_RADIUS];
   max=node_property_defaults[N_RADIUS];
-  Graph::NodeMap<double> actual_map(ms.graph,node_property_defaults[N_RADIUS]);
+  Graph::NodeMap<double> actual_map((mytab.mapstorage).graph,node_property_defaults[N_RADIUS]);
   
   if(node==INVALID)
     {
-      for (NodeIt i(ms.graph); i!=INVALID; ++i)
+      for (NodeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
 	{
 	  double v=fabs(actual_map[i]);
@@ -176,5 +162,4 @@
 int GraphDisplayerCanvas::changeNodeColor (std::string mapname, Node node)
 {  
-  MapStorage& ms = *mytab.mapstorage;
 
   //function maps the range of the maximum and
@@ -182,26 +167,20 @@
   //green in RGB
 
+  Graph::NodeMap<double> * actual_map;
+  actual_map=((mytab.mapstorage).nodemap_storage)[mapname];
+
   double max, min;
 
-  {
-    NodeIt n(ms.graph);
-    min = max = ms.get(mapname, n);
-    for (; n != INVALID; ++n)
-    {
-      if (static_cast<double>(ms.get(mapname, n)) > max)
-        max = ms.get(mapname, n);
-      if (static_cast<double>(ms.get(mapname, n)) < min)
-        min = ms.get(mapname, n);
-    }
-  }
-
-  if(node==INVALID)
-    {
-
-      for (NodeIt i(ms.graph); i!=INVALID; ++i)
+  max=(mytab.mapstorage).maxOfNodeMap(mapname);
+  min=(mytab.mapstorage).minOfNodeMap(mapname);
+
+  if(node==INVALID)
+    {
+
+      for (NodeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
 	{
 	  Gdk::Color color;
 
-	  double w=ms.get(mapname, i);
+	  double w=(*actual_map)[i];
 
 	  if(max!=min)
@@ -221,5 +200,5 @@
       Gdk::Color color;
 
-      double w=ms.get(mapname, node);
+      double w=(*actual_map)[node];
 
       if(max!=min)
@@ -239,5 +218,4 @@
 int GraphDisplayerCanvas::resetNodeColor (Node node)
 {  
-  MapStorage& ms = *mytab.mapstorage;
 
   //function maps the range of the maximum and
@@ -245,5 +223,5 @@
   //green in RGB
 
-  Graph::NodeMap<double> actual_map(ms.graph,node_property_defaults[N_COLOR]);
+  Graph::NodeMap<double> actual_map((mytab.mapstorage).graph,node_property_defaults[N_COLOR]);
 
   double max, min;
@@ -255,5 +233,5 @@
     {
 
-      for (NodeIt i(ms.graph); i!=INVALID; ++i)
+      for (NodeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
 	{
 	  Gdk::Color color;
@@ -295,5 +273,4 @@
 int GraphDisplayerCanvas::changeNodeText (std::string mapname, Node node)
 {
-  MapStorage& ms = *mytab.mapstorage;
 
   //the number in the map will be written on the node
@@ -302,18 +279,28 @@
   //that is the deleter map
 
-  if(node==INVALID)
-    {
-      for (NodeIt i(ms.graph); i!=INVALID; ++i)
+  Graph::NodeMap<double> * actual_map=NULL;
+  actual_map=((mytab.mapstorage).nodemap_storage)[mapname];
+
+  if(node==INVALID)
+    {
+      for (NodeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
 	{
 	  nodemap_to_edit=mapname;
-
-	  nodetextmap[i]->property_text().set_value(
-              static_cast<std::string>(ms.get(mapname, i)));
-	}
-    }
-  else
-    {
-      nodetextmap[node]->property_text().set_value(
-          static_cast<std::string>(ms.get(mapname, node)));
+	  double number=(*actual_map)[i];
+
+	  std::ostringstream ostr;
+	  ostr << number;
+	      
+	  nodetextmap[i]->property_text().set_value(ostr.str());
+	}
+    }
+  else
+    {
+      double number=(*actual_map)[node];
+
+      std::ostringstream ostr;
+      ostr << number;
+	      
+      nodetextmap[node]->property_text().set_value(ostr.str());
     }
   return 0;
@@ -322,5 +309,4 @@
 int GraphDisplayerCanvas::resetNodeText (Node node)
 {
-  MapStorage& ms = *mytab.mapstorage;
 
   //the number in the map will be written on the node
@@ -331,5 +317,5 @@
   if(node==INVALID)
     {
-      for (NodeIt i(ms.graph); i!=INVALID; ++i)
+      for (NodeIt i((mytab.mapstorage).graph); i!=INVALID; ++i)
 	{
 	  nodemap_to_edit="";
Index: graph_displayer_canvas-zoom.cc
===================================================================
--- graph_displayer_canvas-zoom.cc	(revision 194)
+++ graph_displayer_canvas-zoom.cc	(revision 174)
@@ -17,5 +17,5 @@
  */
 
-#include <graph_displayer_canvas.h>
+#include "graph_displayer_canvas.h"
 #include <cmath>
 
